#include <imsls.h>
#include <stdio.h>
#include <math.h>
int main()
{
int i, j;
int ncov=2, ngroup=4, nobs=40;
int ni[4] = {10, 10, 10, 10};
float aov[15], testpl[10], adj_aov[8], xymean[5*5], covm[4*4];
float x1[40] = {
	78.0, 90.0, 94.0, 71.0, 99.0, 80.0, 83.0, 75.0, 62.0, 67.0, 
	78.0, 99.0, 80.0, 75.0, 94.0, 91.0, 75.0, 63.0, 62.0, 67.0, 
	78.0, 83.0, 79.0, 70.0, 85.0, 83.0, 71.0, 66.0, 67.0, 67.0, 
	77.0, 71.0, 78.0, 70.0, 95.0, 96.0, 71.0, 63.0, 62.0, 67.0
};
float x2[40] = {
	61.0, 59.0, 76.0, 50.0, 61.0, 54.0, 57.0, 45.0, 41.0, 40.0, 
	74.0, 75.0, 64.0, 48.0, 62.0, 42.0, 52.0, 43.0, 50.0, 40.0, 
	80.0, 61.0, 62.0, 47.0, 59.0, 42.0, 47.0, 42.0, 40.0, 40.0, 
	62.0, 55.0, 62.0, 43.0, 57.0, 51.0, 41.0, 40.0, 45.0, 39.0, 
};
float y[40] = {
	1.40, 1.79, 1.72, 1.47, 1.26, 1.28, 1.34, 1.55, 1.57, 1.26, 
	1.61, 1.31, 1.12, 1.35, 1.29, 1.24, 1.29, 1.43, 1.29, 1.26, 
	1.67, 1.41, 1.73, 1.23, 1.49, 1.22, 1.39, 1.39, 1.56, 1.36, 
	1.40, 1.47, 1.37, 1.15, 1.22, 1.48, 1.31, 1.27, 1.22, 1.36
};
float x[40*2], stderr, delta, t, df, pvalue;
/* setup covariate input matrix */
for(i=0; i<nobs; i++){
	x[i*ncov  ] = x1[i];
	x[i*ncov+1] = x2[i];
}
imsls_f_ancovar(ngroup, ncov, ni, y, x, 
				IMSLS_PARALLEL_TESTS_USER, testpl,
				IMSLS_ADJ_ANOVA_USER, adj_aov,
				IMSLS_XYMEAN_USER, xymean,
				IMSLS_COV_MEANS_USER, covm,
				IMSLS_RETURN_USER, aov, 0);
	
printf("\n");
printf("             * * * TEST FOR PARALLELISM  * * * \n");
printf("                       Sum of     Mean         F     Prob of\n");
printf("SOURCE           DF    Squares   Square       TEST   Larger F\n");
printf("Extra due to\n");
printf("Nonparallelism %3.0f %10.2f    %7.2f    %7.5f   %5.3f\n",
		testpl[0], testpl[3], testpl[6], testpl[8], testpl[9]);
printf("Extra Assuming\n");
printf("Nonparallelism %3.0f %10.2f    %7.2f \n", 
		testpl[1], testpl[4], testpl[7]);
printf("Error Assuming\n");
printf("Parallelism    %3.0f %10.2f   \n", testpl[2], testpl[5]);

printf("\n");
printf("             * * * ANALYSIS OF VARIANCE * * * \n");
printf("                  Sum of         Mean                Prob of\n");
printf("Source   DF      Squares        Square    Overall F  Larger F\n");
printf("Model   %3.0f      %f     %f    %f    %5.4f\n",
	        aov[0], aov[3], aov[6], aov[8], aov[9]);
printf("Error   %3.0f      %f     %f      \n", aov[1], aov[4], aov[7]);
printf("Total   %3.0f      %f  \n", aov[2], aov[5]);

printf("\n");
printf("         * * * ADJUSTED ANALYSIS OF VARIANCE  * * * \n");
printf("                                Sum of        F     Prob of\n");
printf("Source                    DF    Squares      TEST   Larger F\n");
printf("Groups after Covariates %3.0f   %10.2f    %5.2f    %7.5f\n",
	        adj_aov[0], adj_aov[2], adj_aov[4], adj_aov[6]);
printf("Covariates after Groups %3.0f   %10.2f    %5.2f    %7.5f\n",
	        adj_aov[1], adj_aov[3], adj_aov[5], adj_aov[7]);

printf("\n           * * * GROUP MEANS * * * \n");
printf("GROUP  | Unadjusted   |  Adjusted |  Std. Error\n");
for(i=0; i<ngroup; i++)	{
	stderr = sqrt(covm[i*ngroup + i]);
	printf("  %d    |   %5.4f     |   %5.4f  |   %7.4f\n", i+1,
		xymean[i*(ngroup+1)+ngroup-1], xymean[i*(ngroup+1)+ngroup],
		stderr);
}
printf("\n      * * * STUDENT-T MULTIPLE COMPARISONS * * * \n");
printf(" GROUPS  |    DIFF   | Std. Error | Student-t | P-Value\n");
for(i=0; i<ngroup-1; i++){
	for(j=i+1; j<ngroup; j++){
		delta  = xymean[i*(ngroup+1)+ngroup] - 
				xymean[j*(ngroup+1)+ngroup];
		stderr = sqrt(covm[i*ngroup+i]+covm[j*ngroup+j]-
				2.0*covm[i*ngroup+j]);
		t      = delta/stderr;
		df     = xymean[i*(ngroup+1)]+xymean[j*(ngroup+1)]-2;
		pvalue = 1.0 - imsls_f_t_cdf(t, df);
		printf(" %d vs %d  |  %7.4f  |  %7.4f   | %7.3f   | %7.5f\n",
				i+1, j+1, delta, stderr, t, pvalue);
	}
}
}
